//=============================================================================
// AnnaNavarreCarcass.
//=============================================================================
class AnnaNavarreCarcass extends DeusExCarcass;

function ChunkUp(int Damage)
{
	local int i;
	local float size;
	local Vector loc;
	local FleshFragment chunk;
	local DeusExFragment ss;

	size = (CollisionRadius + CollisionHeight) / 2;
	if (size > 10.0)
	{
		for (i=0; i<size/4.0; i++)
		{
			loc.X = (1-2*FRand()) * CollisionRadius;
			loc.Y = (1-2*FRand()) * CollisionRadius;
			loc.Z = (1-2*FRand()) * CollisionHeight;
			loc += Location;
			chunk = spawn(class'FleshFragment', None,, loc);
			if (chunk != None)
			{
				chunk.DrawScale = size / 25;
				chunk.SetCollisionSize(chunk.CollisionRadius / chunk.DrawScale, chunk.CollisionHeight / chunk.DrawScale);
				chunk.bFixedRotationDir = True;
				chunk.RotationRate = RotRand(False);
			}
			ss = Spawn(class'MetalFragment', None,, loc);
			if ( ss != None )
			{
				ss.CalcVelocity(Velocity, 256);
				ss.DrawScale = 0.5;
				ss.Skin = GetMeshTexture();
			}
		}
	}

	Super(Carcass).ChunkUp(Damage);
}

defaultproperties
{
     Mesh2=LodMesh'DeusExCharacters.GFM_TShirtPants_CarcassB'
     Mesh3=LodMesh'DeusExCharacters.GFM_TShirtPants_CarcassC'
     Mesh=LodMesh'DeusExCharacters.GFM_TShirtPants_Carcass'
     DrawScale=1.100000
     MultiSkins(0)=Texture'DeusExCharacters.Skins.AnnaNavarreTex0'
     MultiSkins(1)=Texture'DeusExItems.Skins.PinkMaskTex'
     MultiSkins(2)=Texture'DeusExItems.Skins.PinkMaskTex'
     MultiSkins(3)=Texture'DeusExItems.Skins.GrayMaskTex'
     MultiSkins(4)=Texture'DeusExItems.Skins.BlackMaskTex'
     MultiSkins(5)=Texture'DeusExCharacters.Skins.AnnaNavarreTex0'
     MultiSkins(6)=Texture'DeusExCharacters.Skins.PantsTex9'
     MultiSkins(7)=Texture'DeusExCharacters.Skins.AnnaNavarreTex1'
     CollisionRadius=44.000000
     CollisionHeight=7.700000
}
